/*
** $Id: sim_func_ext.h,v 1.13 1997/07/23 21:52:47 venkat Exp $
** $Log: sim_func_ext.h,v $
** Revision 1.13  1997/07/23 21:52:47  venkat
** Added extern declaration of quitCallback()
**
** Revision 1.12  1997/05/23 01:40:49  dhb
** Added DeleteMsgReferringToData() which deletes outbound messages
** with data slots pointing to data which is no longer valid.
**
** Revision 1.11  1997/05/23 00:28:40  dhb
** Added decl for RemapMsgData().
**
** Revision 1.10  1996/05/16 21:46:31  dhb
** Change messages back to a linked structure.
**
** MsgIn and MsgOut are now unified into a single Msg structure which
** is linked on two lists (inbound and outbound).
**
** GetMsgInByMsgOut() and GetMsgOutByMsgIn() are now macros which just
** return the Msg structure.
**
** The MsgIn and MsgOut types are still supported but are now aliases
** for Msg.
**
 * Revision 1.9  1994/08/31  02:57:39  dhb
 * Added FieldNameProper().
 *
 * Revision 1.8  1994/05/27  22:26:58  dhb
 * Added all the fieldlist interface functions.
 *
 * Revision 1.7  1993/12/23  03:00:58  dhb
 * Extended Objects (mostly complete)
 *
 * Revision 1.6  1993/06/29  18:56:07  dhb
 * Extended objects (incomplete)
 *
 * Revision 1.5  1993/04/23  22:11:48  dhb
 * Added various GetMsg...By...() functions
 *
 * Revision 1.4  1993/04/23  21:52:36  dhb
 * Added extern statements for additional extended field functions.
 *
 * Revision 1.3  1993/03/10  23:15:58  dhb
 * Extended element fields.
 *
 * Revision 1.2  1992/12/18  21:19:06  dhb
 * Made AddMsgIn and AddMsgOut extern (defined in sim_msg.c) to
 * support compact messages
 *
 * Revision 1.1  1992/10/27  21:19:36  dhb
 * Initial revision
 *
*/


extern char				*ArgListToString();
extern FILE				*CurrentScriptFp();
extern FILE				*NextScriptFp();
extern float				GetVarNumData();
extern char				*GetVarStrData();
extern char				*array();
extern PFI				LoadFunction();
extern FuncTable			GetCommand();
extern PFI				GetFuncAddress();
extern char				*FindSrcLine();
extern char				*GetFuncName();
extern char				*date();
extern float				Atof();
extern double				Atod();
extern char				*ftoa();
extern char				*itoa();
extern char				*GetNameAndIndex();

extern struct region_mask_type		*GetRegionMask();
extern struct delay_table_type		*GetDelayTable();

extern struct connection_type		*AddConnection();
extern struct element_type		*NextEnabledTreeElement();

extern char				*GetParentComponent();
extern char				*GetFieldComponent();
extern char				*GetPathComponent();
extern char				*GetBaseComponent();

extern char				*GetValue();

extern char				*Pathname();

extern Buffer				*FindBuffer();

extern Connection			*GetConnection();

extern Element 				*GetElement();
extern struct element_type 		*GetChildElement();

extern struct buffer_type		*CreateBuffer();
extern Projection			*CreateProjection();
extern struct connection_type		*CreateConnection();
extern struct element_type 		***CreateGrid();

extern struct element_type		*CopyElement();
extern Buffer				*CopyBuffer();
extern Projection			*CopyProjection();

extern Event		 		*FindEvent();
extern Event		 		*PreviousEvent();

extern char				*AllocateSpecific();
extern char				*SpecificField();

extern double				Gear();
extern double				AB2();
extern double				AB3();
extern double				AB4();
extern double				AB5();
/* new integration functions (BPG 22-5-91) */
extern double				Euler_Predictor_Corrector();
extern double				Runge_Kutta();
/* end of new functions (BPG 24-5-91) */
extern double				PasteOnSpike();

extern Element			*GetCurrentElement();
extern FILE				*SearchForScript();
extern char				*getenv();
extern double				IntegrateMethod();
extern char				*GetElementtype();
extern char				*CalculateAddress();
extern double				MessageData();
extern MsgIn				*AddMsgIn();
extern MsgOut				*AddMsgOut();
extern MsgList				*GetMsgListByName();
extern MsgList				*GetMsgListByType();
extern MsgOut				*GetMsgOutByNumber();
extern MsgIn				*GetMsgInByNumber();
extern void				RemapMsgData();
extern void				DeleteMsgReferringToData();
extern double				DirectIntegrate();
extern char				**CopyArgv();
extern  struct mask_type		*GetMaskFromArgv();

extern char				*getobjenv();
extern Element				*NextElement();
extern Element				*GetElement();
extern Element				*Create();
extern Element				*CopyElementTree();
extern char				*Pathname();
extern Element 				*CreateElement();
extern GenesisObject			*GetObject();
extern GenesisObject			*BaseObject();
extern GenesisObject			*ObjectCacheCheck();
extern GenesisObject			*ObjectModify();
extern char				*CopyString();
extern char				*GetClassName();
extern char				*GetFieldAdr();
extern char				*GetFieldStr();
extern Action				*GetAction();
extern char				*Actionname();
extern Event				*CopyEvents();
extern ElementList			*WildcardGetElement();
extern ActionList			*GetActionListByType();
extern PFI				GetActionFunc();
extern Element				*RootElement();
extern Element				*WorkingElement();
extern Element				*RecentElement();
extern char				**NULLArgv();
extern ElementStack 			*NewPutElementStack();
extern Element 				*NewFastNextElement();
extern Element 				*NewNextElement();
extern char				*FieldValue();

extern char*				ElmFieldValue();
extern int				SetElement();
extern char*				FieldNameProper();

extern int				AddExtField();
extern int				DelExtField();
extern void				DelAllExtFields();
extern int				SetExtField();
extern char*				GetExtField();
extern char*				GetExtFieldAdr();
extern char*				GetExtFieldNameByAdr();
extern int				CopyExtFields();
extern int				MemUsageExtFields();
extern void				DisplayExtFields();
extern void				AddExtFieldsToStr();

extern int				AddFieldList();
extern int				DelFieldList();
extern int				AddDefaultFieldList();
extern void*				GetFieldListInfo();
extern int				GetFieldListType();
extern int				SetFieldListType();
extern int				GetFieldListProt();
extern int				SetFieldListProt();
extern char*				GetFieldListDesc();
extern int				SetFieldListDesc();
extern int				FieldIsPermanent();
extern int				FieldListExists();
extern int				CopyFieldList();
extern int				FieldListEqual();

extern FLI*				FLIOpen();
extern int				FLIValid();
extern int				FLIType();
extern int				FLIProt();
extern char*				FLIName();
extern void*				FLIInfo();
extern int				FLIFind();

/** Command Callbacks **/

extern void 				quitCallback();
