/*
** $Id: system_deps.h,v 1.6 1997/07/18 03:14:53 dhb Exp $
** $Log: system_deps.h,v $
** Revision 1.6  1997/07/18 03:14:53  dhb
** Fix for getopt problem; getopt(), optopt and optind are now
** G_getopt(), G_optopt and G_optind.
**
** Revision 1.5  1995/04/14 18:03:28  dhb
** Added check for getopt macro already defined.
**
** Revision 1.4  1994/04/14  19:26:27  dhb
** DEC Alpha compatability
**
** Revision 1.3  1993/10/15  18:26:37  dhb
** Fixed typo in Solaris patches.
**
** Revision 1.2  1993/09/17  16:25:14  dhb
** Solaris compatibility
**
** Revision 1.1  1992/12/11  19:05:42  dhb
** Initial revision
**
*/

/*
** Global include file for system dependent functions
** (c) Michael D. Speight 1991
*/

/* mds3 changes */
#ifdef i860
/* some useful constants */
#define M_E   2.7182818284590452354
#define M_PI  3.14159265358979323846
#endif
#ifdef Solaris
#define	jmp_buf		sigjmp_buf
#define	setjmp(buf)	sigsetjmp(buf,1)
#define	longjmp		siglongjmp
#endif
#ifdef SYSV
/* Define 'bcopy()' and 'bzero()' */
#define bcmp(s1, s2, length)  memcmp(s1, s2, length)
#define bcopy(s1, s2, length) (int)memcpy(s2, s1, length)
#define bzero(s1, length) (int)memset(s1, 0, length)
#endif

#ifdef BSD
#define HAVE_VFORK
#endif

#if defined(decalpha)
#define WORD long
#define ADDR long
#else
#define WORD int
#define ADDR int
#endif

#define WORDSIZE sizeof(WORD)
#define ADDRSIZE sizeof(ADDR)
