//genesis
/**********************************************************************
** This program is part of kinetikit and is
**           copyright (C) 1995-1997 Upinder S. Bhalla.
** It is made available under the terms of the GNU General Public License. 
** See the file COPYRIGHT for the full notice.
**********************************************************************/
//ksim : this file has functions for building up the
// basic infrastructure of the kkit simulations.

function kbegin
	initdump -ignoreorphans 1
	// The table object needs to have its dump fields specified
	// explicitly
	simobjdump table input output alloced step_mode stepsize

	if (!{exists /kinetics})
		create neutral /kinetics
	end
	if (!{exists /kclip})
		create neutral /kclip
		disable /kclip
	end
	floatformat %0.5g
end

// This function resets the simulation parameters
function kparms
		setclock {FASTCLOCK} {FASTDT}
		setclock {SIMCLOCK} {SIMDT}
		setclock {CONTROLCLOCK} {CONTROLDT}
		setclock {PLOTCLOCK} {PLOTDT}
		// setclock {TABLECLOCK} {TABLEDT}
		if (DO_X)
			setfield /control/runtime value {MAXTIME}
			setfield /graphs/#[TYPE=xgraph] xmax {MAXTIME}
		end
end
